/*******************************************************************************
 * Copyright (c) 2009 Information-technology Promotion Agency, Japan.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
package benten.cat.glossary.ui.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.text.ITextSelection;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IEditorActionDelegate;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.PartInitException;

import benten.cat.glossary.ui.CatGlossaryUiPlugin;
import benten.cat.glossary.ui.views.GlossaryView;

/**
 * 
 * ★基本設計「翻訳支援機能: 用語対訳集検索機能」に対応します。
 */
public class ShowGlossaryAction implements IEditorActionDelegate {

	private IEditorPart targetEditor;
	private ISelection selection;

	public void selectionChanged(IAction action, ISelection selection) {
		this.selection = selection;
	}

	public void setActiveEditor(IAction action, IEditorPart targetEditor) {
		this.targetEditor = targetEditor;
	}

	public void run(IAction action) {
		try {
			final GlossaryView view = (GlossaryView) targetEditor.getSite().getPage().showView(
					GlossaryView.class.getName());
			final ITextSelection textSelection = (ITextSelection) selection;
			view.showGlossary(textSelection.getText());
		} catch (final PartInitException e) {
			CatGlossaryUiPlugin.getDefault().log(e);
		}
	}
}
